/*
 * Copyright (c) 1991       by the University of Washington
 * Copyright (c) 1992, 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <uw-copyright.h> and <usc-copyr.h>.
 *
 * Written  by bcn 1991     as get_next_request in rdgram.c (Prospero)
 * Modified by bcn 1/93     modularized and incorporated into new ardp library
 */

#include <uw-copyright.h>
#include <usc-copyr.h>

#include <stdio.h>
#include <sys/time.h>
#ifdef AIX
#include <sys/select.h>
#endif
#include <ardp.h>

extern RREQ	ardp_pendingQ;
extern RREQ	ardp_runQ;
extern int	pQNlen;
extern int	pQlen;
extern int	ardp_srvport;
extern int	ardp_prvport;

#define max(x,y) (x > y ? x : y)

/*
 * ardp_get_nxt - return next request for server
 *
 *   ardp_get_nxt returns the next request to be processed by the server.
 *   If no requests are pending, ardp_get_nxt waits until a request
 *   arrives, then returns it.
 */
RREQ ardp_get_nxt()
{
    RREQ	nextreq;
    fd_set	readfds;
    int		tmp;

 tryagain:
    ardp_accept();

    /* return next message in queue */
    if(ardp_pendingQ) {
	nextreq = ardp_pendingQ;
	EXTRACT_ITEM(nextreq, ardp_pendingQ);
	pQlen--;if(nextreq->priority > 0) pQNlen--;
	nextreq->svc_start_time.tv_sec = time(NULL);	
	APPEND_ITEM(nextreq,ardp_runQ);
	return(nextreq);
    }

    /* if queue is empty, then wait till somethings comes */
    /* in, then go back to start                          */
    FD_ZERO(&readfds);
    if(ardp_srvport != -1) FD_SET(ardp_srvport, &readfds);
    if(ardp_prvport != -1) FD_SET(ardp_prvport, &readfds); 
    tmp = select(max(ardp_srvport,ardp_prvport) + 1, &readfds, 
		 (fd_set *)0, (fd_set *)0, NULL);
    goto tryagain;
}

